;----ATMEL BASIC deffinition--------------
.device ATmega8
.include "atmeldef.inc" 

;----deffinition der PORTVARIBLEN---------------
.equ     sync      =0     ;Port B
.equ     pixel     =7     ;Port D

         .cseg
         .org	0


;DDxn	PORTxn	PUD	I/O 	Pull-up 	Comment
;0 	0 	X 	Input 	No 		Tri-state (Hi-Z)
;0 	1 	0 	Input 	Yes		Pxn will source current if external pulled low.
;0 	1 	1 	Input 	No 		Tri-state (Hi-Z)
;1 	0 	X 	Output 	No 		Output Low (Sink)
;1 	1 	X 	Output 	No 		Output High (Source)


;-------setze Stackpointer auf Adresse 0x045F-----
          ldi    r17, 0x5F
          out    SPL, r17
          ldi    r17, 0x04
          out    SPH, r17
;-------------------------------------------------

;------setze VIDEO PORTS-------------------
	sbi	DDRD, pixel	;setze Port auf Output
	sbi	DDRB, sync	;setze Port auf Output
	cbi	PORTD, pixel	;setze Port auf Low
	cbi	PORTB, sync	;setze Port auf Low
;------------------------------------------


;------------- Aufbau einer Videozeile ------------------
;1s  = 16 takte bei 16 MHz Quarz
;64s = 1024 Takte  (Zeilendurchlauf)
;4s  =   64 Takte  (sync)
;8s  =  128 Takte  (Blackscreen)
;52s =  832 Takte  (Videoinformation)



videostart:

;########################## VIDEODATEN 52s ##################################
;--------13s = 208 Takte Black-------------------------
	sbi	PortB, sync	;2 setze sync auf High
	cbi	PORTD, pixel	;2 setze pixel auf Low

	ldi	r17, 0x44	;-----
pause1:	dec	r17		;   204 Taktschleife
	brne	pause1		;-----
;-------------------------------------------------------



;--------5s = 80 Takte Weiss -------------------
	sbi	PORTD, pixel	;2 setze pixel auf High

	ldi	r17, 0x1A	;-----
pause2:	dec	r17		;   78 Taktschleife
	brne	pause2		;-----
;-------------------------------------------------------



;--------10s = 160 Takte Black -------------------
	cbi	PORTD, pixel	;2 setze pixel auf Low

	ldi	r17, 0x34	;-----
pause3:	dec	r17		;
	brne	pause3		;   158 Taktschleife
	nop			;
	nop			;-----
;-------------------------------------------------------


;--------5s = 80 Takte Weiss -------------------
	sbi	PORTD, pixel	;2 setze pixel auf High

	ldi	r17, 0x1A	;-----
pause4:	dec	r17		;   78 Taktschleife
	brne	pause4		;-----
;-------------------------------------------------------


;--------19s = 304 Takte Black-------------------------
	cbi	PORTD, pixel	;2 setze pixel auf Low

	ldi	r17, 0x64	;-----
pause5:	dec	r17		;   
	brne	pause5		;   302 Taktschleife
	nop			;
	nop			;-----
;-------------------------------------------------------








;################### Horizontaler SYNC Impuls 12s ############################

;--------4s = 64 Takte Sync-------------------------
	cbi	PortB, sync	;2 setze sync auf Low
	cbi	PORTD, pixel	;2 setze pixel auf Low

	ldi	r17, 0x14	;-----
sync1:	dec	r17		;   60 Taktschleife
	brne	sync1		;-----
;-------------------------------------------------------

;--------8s = 128 Takte Blackscreen--------------------
	sbi	PortB, sync	;2 setze sync auf High

	ldi	r17, 0x29	;-----
sync2:	dec	r17		;   124 Taktschleife
	brne	sync2		;
	nop			;-----
;-------------------------------------------------------

	rjmp	videostart	;2




        .exit