;----ATMEL BASIC deffinition--------------
.device ATmega8
.include "atmeldef.inc" 

;----deffinition der PORTVARIBLEN---------------
.equ     sync      =0     ;Port B
.equ     pixel     =7     ;Port D

         .cseg
         .org	0


;DDxn	PORTxn	PUD	I/O 	Pull-up 	Comment
;0 	0 	X 	Input 	No 		Tri-state (Hi-Z)
;0 	1 	0 	Input 	Yes		Pxn will source current if external pulled low.
;0 	1 	1 	Input 	No 		Tri-state (Hi-Z)
;1 	0 	X 	Output 	No 		Output Low (Sink)
;1 	1 	X 	Output 	No 		Output High (Source)


;-------setze Stackpointer auf Adresse 0x045F-----
          ldi    r17, 0x5F
          out    SPL, r17
          ldi    r17, 0x04
          out    SPH, r17
;-------------------------------------------------

;------setze VIDEO PORTS-------------------
	sbi	DDRD, pixel	;setze Port auf Output
	cbi	PORTD, pixel	;setze Port auf Low
;------------------------------------------

;------setze Graybar + sync PORTS ----------------
          ldi    r17, 0x01	;setze Graybarports auf TRISTATE
          out    DDRB, r17	;setze sync Port auf Output Low
          ldi    r17, 0x00
          out    PORTB, r17
;------------------------------------------

;------------- Aufbau einer Videozeile ------------------
;1s  = 16 takte bei 16 MHz Quarz
;64s = 1024 Takte  (Zeilendurchlauf)
;4s  =   64 Takte  (sync)
;8s  =  128 Takte  (Blackscreen)
;52s =  832 Takte  (Videoinformation)


videostart:

;##########( GRAYBAR schwarz -> weiss 832 Takte)###################
; 24 takte sind schon fesr vergeben, die restl. takte werden nun durch
; 8 geteilt um die lnge fr ein balken zu erhalten. 808:8 = 101.
; Somit brauchen wir 101 takte fr ein balken. 

graybar1:
	cbi    DDRD, pixel	;2 setze Pixelport auf TRISTATE

gr0:	sbi	DDRB, 1		;2 setze Port PB1 auf OUTPUT
	sbi	DDRB, 2		;2 setze Port PB2 auf OUTPUT
	sbi	DDRB, 3		;2 setze Port PB3 auf OUTPUT

	ldi	ZH, 0x02	;1 setze additionswert auf 0x02
	ldi	r17, 0x1	;1 initialiesiere Graybar Startwert

gr1:	out	PORTB, r17	;1------------------
	ldi	r19, 0x20	;-----
gr2:	dec	r19		;    96 t
	brne	gr2		;-----             808 t           
	add	r17, ZH		;1
	cpi	r17, 0x11	;1
	brne	gr1		;1-2
	nop			;1------------------

	cbi	DDRB, 1		;2 setze Port PB1 auf INPUT
	cbi	DDRB, 2		;2 setze Port PB2 auf INPUT
	cbi	DDRB, 3		;2 setze Port PB3 auf INPUT
	cbi	PORTB, 1	;2 setze Port PB1 auf TRISTATE
	cbi	PORTB, 2	;2 setze Port PB2 auf TRISTATE
	cbi	PORTB, 3	;2 setze Port PB3 auf TRISTATE

	sbi    DDRD, pixel	;2 setze Pixelport auf OUTPUT
;##################################################################

	rcall	hsync		;190
	rjmp	videostart	;2



;/////////////////////////////////////////////////////////////////////////////
;//              Subroutinen                                                //
;/////////////////////////////////////////////////////////////////////////////


;################### Horizontaler SYNC Impuls 12s (190 takte)##################
hsync:
;+3 takte vom rcall
;+4 takte vom Return
;--------4s = 64 Takte Sync-------------------------
	cbi	PortB, sync	;2 setze sync auf Low
	cbi	PORTD, pixel	;2 setze pixel auf Low

	ldi	r17, 0x14	;-----
sync1:	dec	r17		;   60 Taktschleife
	brne	sync1		;-----
;-------------------------------------------------------

;--------8s = 128 Takte Blackscreen--------------------
	sbi	PortB, sync	;2 setze sync auf High

	ldi	r17, 0x27	;-----
sync2:	dec	r17		;   117 Taktschleife
	brne	sync2		;-----
;-------------------------------------------------------

	ret			;4
;###############################################################################


        .exit